/* Модель понимания объектов внимания для объектов экстремального внимания типа extremImportance
т.е. имеющих наибольшую значимость среди всех других.

Модель понимани для данного объекта - это все кадры эпизодической памяти EpisodicTreeNode, где он участвует
в виде структыр ObjModel.
В каждом кадре есть связь с тем, к чему привели недавние действия (следующие эпизоды памяти после ObjModel.ID)
и есть полное описание условий того момента (из EpisodicTreeNodeFromID[ObjModel.ID]).

Становится возможным использовать схожесть моделей (совместное учатие в эпизоде) для предположения свойств.

// текущий значимый объект внимания определяется в func consciousnessElementary(
var extremImportanceObject *extremImportance
// текущий субъект внимания (объект внимания к собственным мыслям)    ЕЩЕ НЕТ ТАКОГО по аналогии с importance.go
var extremImportanceMentalObject *extremImportance

Новый экстремальный образ создается в importance_funcs.go func getTopAttentionObject(eij []extremImportance)


*/

package psychic

/////////////////////////////////////////////////////////////////////

/*
	Элемент отдельного эпизода с эктремальным образом восприятия (extremImportance.ID)

для вывода всех таких объектов в эпиз.памяти - Модель понимания значимости объекта.
Используется для выборки ЭкстремальныхОбъектовВнимания в эпиз.памяти
*/
type ObjModel struct { //
	ID        int // ID эпиз памяти
	objID     int // объект значимости - в зависимости от kind м.б. одним из importanceTypeName[] типов
	kind      int // тип объекта importanceType
	extremVal int // экстремальная значимость
}

/*
	Временный массив создается только на время его инфо-обработки с помощью

func getUnderstandingModel(objID int, kind int)

Для каждого экстремального объекта делается своя выборка кадров при сканировании всего дерева эпиз.памяти.
*/
var UnderstandingModel []ObjModel

///////////////////////////////////////////////////////

/*
	Элемент отдельного эпизода с Правилами

для вывода всех таких Правил в эпиз.памяти - Модель понимания значимости объекта.
Используется для выборки Модели понимания Правил
*/
type RulesModel struct { //
	ID     int // ID эпиз памяти
	objID  int // Стимул ActionsImage.ID
	Action int // Ответ ActionsImage.ID
	Effect int // эффект от действий
}

/*
	Временный массив создается только на время его инфо-обработки с помощью

Для каждого экстремального объекта делается своя выборка кадров при сканировании всего дерева эпиз.памяти.
*/
var UnderstandingRulesModel []RulesModel

///////////////////////////////////////////////////////

/*
	Временный массив всех моделей понимания

(В прежней версии это был единственный и записываемый в файл массив)
Теперь он временный и обновляется по каждому запросу к выборке эпиз.памчяти:
func getAllExtrОbjIDarr()

В UnderstandingModelArr [][]int индекс - ID ЭкстремальноЗначащих Объектов, значение - массив ID кадров эпиз.памяти

Шаблон использования:
WriteUnderstandingModelArr(index, value)
addUnderstandingModelArr(index)
node,ok:=ReadeUnderstandingModelArr(id)
if !ok {return }
В случае передобра range НУЖНО ПРОВЕРЯТЬ if v==nil{continue}:
for _, v := range{
if v==nil{continue}
*/
var UnderstandingModelArr [][]int // сам массив
// var AFromID = make([]*aNode, len(strArr))//задать сразу имеющиеся в файле число при загрузке
// запись члена
func WriteUnderstandingModelArr(index int, value []int) {
	addUnderstandingModelArr(index)
	UnderstandingModelArr[index] = value
}
func addUnderstandingModelArr(index int) {
	if index >= len(UnderstandingModelArr) {
		newSlice := make([][]int, index+1)
		copy(newSlice, UnderstandingModelArr)
		UnderstandingModelArr = newSlice
	}
}

// считывание члена
func ReadeUnderstandingModelArr(index int) ([]int, bool) {
	if index >= len(UnderstandingModelArr) || UnderstandingModelArr[index] == nil {
		return nil, false
	}
	return UnderstandingModelArr[index], true
}

///////////////////////////////////////
